!====================================================================
SUBROUTINE cal_stress
  USE common
  IMPLICIT NONE
!
  SELECT CASE(type_estr_m(mat_e(ielem)))
!
!--- `eޗ
  CASE(1)
    CALL cal_stress1
!
!--- `eޗ
  CASE(2)
    CALL cal_stress2
!  
!--- eYޗ
  CASE(3)
    CALL cal_stress3
!  
  CASE DEFAULT
    WRITE(2,'(A)') "Wrong type_estr_m in sub.cal_stress"
    STOP
  END SELECT
!
END SUBROUTINE cal_stress
!====================================================================
SUBROUTINE cal_stress1
  USE common
  IMPLICIT NONE
!
!--- `eޗ (type_estr_m = 1) 
!
  REAL(p):: lamda
  REAL(p):: stst
!
!--- 
  lamda=0.0_p
!
!--- ޗ萔̐ݒ
  lamda=prop_estr_m(mat_e(ielem),1)
!
!--- Ђݑɂ鉞͂̌vZ
!  stst= stst_e_i(ielem,iintp)
!  sts_i= stst + lamda*del_stn_i
!
!--- ЂݑSɂ鉞͂̌vZ
  sts_i= lamda*stn_i
!
!--- ͂̕ۑpϐւ̋L^
  sts_e_i(ielem,iintp)=sts_i
!
!--- eW̐ݒ
!
  dep_i=lamda
!
END SUBROUTINE cal_stress1
!====================================================================
SUBROUTINE cal_stress2
  USE common
  IMPLICIT NONE
!
!--- `eޗ (type_estr_m = 2)
!
  REAL(p):: n_0s, voidr_0, sts0, kappa
!
!--- 
  n_0s=0.0_p; voidr_0=0.0_p
  sts0=0.0_p; kappa=0.0_p
!
!--- {ޗf[^iԌj
  n_0s=prop_base_m(mat_e(ielem),1)
!
!--- ޗ萔
!      1: 
!      2: cwiekwj
  sts0=prop_estr_m(mat_e(ielem),1)
  kappa=prop_estr_m(mat_e(ielem),2)
!
!--- Ԍ珉ԌvZ
  voidr_0=n_0s/(1.0_p-n_0s)
!
!--- e\iw֐fj牞͂vZ
  sts_i=sts0*exp(-((1.0_p+voidr_0)/kappa)*stn_i)
!
!--- XVꂽ͂ۑpϐɋL^
  sts_e_i(ielem,iintp)=sts_i
!
!--- eڐW̐ݒ
  dep_i=-((1.0_p+voidr_0)/kappa)*sts_i
!
END SUBROUTINE cal_stress2
!====================================================================
SUBROUTINE cal_stress3
  USE common
  IMPLICIT NONE
!
!--- eYޗ (type_estr_m = 3)
!
  INTEGER:: id_ep, iter_retmap
  REAL(p):: n_0s, voidr_0, sts0, iso_hp0, kappa, lamda
  REAL(p):: iso_hpt, iso_hp_trial, stn_elast_trial
  REAL(p):: stnt_plast, stn_elast, stn_plast, sts_trial
  REAL(p):: fyield, del_fyield, del_gamma, correct_del_gamma
!
!--- 
  n_0s=0.0_p; voidr_0=0.0_p
  sts0=0.0_p; kappa=0.0_p; lamda=0.0_p; 
!
!--- {ޗf[^iԌj
  n_0s=prop_base_m(mat_e(ielem),1)
!
!--- ޗ萔
!      1: 
!      2: cwiekwj
!      3: ~
!      4: kwieYkwj
  sts0=prop_estr_m(mat_e(ielem),1)
  kappa=prop_estr_m(mat_e(ielem),2)
  iso_hp0=prop_estr_m(mat_e(ielem),3)
  lamda=prop_estr_m(mat_e(ielem),4)
!
!--- Ԍ珉ԌvZ
  voidr_0=n_0s/(1.0_p-n_0s)
!
!--- OXebv̈~
  iso_hpt=iso_hpt_e_i(ielem,iintp)
!
  IF(ABS(iso_hpt) < zero) then
   iso_hpt=iso_hp0
!    iso_hpt=iso_hp0/sts0*stst_e_i(ielem,iintp)
!    IF(ABS(iso_hpt) < zero) iso_hpt=iso_hp0
  ENDIF
!
!--- d֐đOXebv̑YЂ݂vZ
  stnt_plast=-((lamda-kappa)/(1.0_p+voidr_0))*log(iso_hpt/iso_hp0)
!
!--- Xebv̑SЂ݂ƑOXebv̑YЂ݂玎seЂ݂vZ
  stn_elast_trial = stn_i-stnt_plast
!
!--- seЂ݂e\iw֐fjɑĎs͂vZ
  sts_trial=sts0*exp(-((1.0_p+voidr_0)/kappa)*stn_elast_trial)
!
!--- OXebv̈~͂slƂ
  iso_hp_trial=iso_hpt
!
!--- ͂ƈ~͂̎sl~֐ɑC̐ɂ蕉הs
  fyield=iso_hp_trial-sts_trial
!
!
  IF(fyield <= 0.0_p) THEN
!--- CASE-1: eEׂƔ肳ꂽꍇ
!
!--- ͂ƈ~͂̎slXebv̒lƂč̗p
    sts_i=sts_trial
    iso_hp_i=iso_hp_trial
!
!--- eڐW̐ݒ
    dep_i=-((1.0_p+voidr_0)/kappa)*sts_i
!
  ELSEIF(fyield > 0.0_p) THEN
!--- CASE-2: YׂƔ肳ꂽꍇ
!            Newton-Raphson@ō~֐f=0Y搔ɂĉ
!
!    WRITE(2,'(A21,I10,A7,I10)') "Return map for ielem ",ielem," iintp ",iintp
!    WRITE(2,'(A)') "iter_retmap  err  err/err0"
!
!--- Newton-Raphson@̏lݒ
    del_gamma=0.0_p
!
!--- Newton-Raphson@Jn
    iteration_retmap: DO iter_retmap=1,max_iter
!
!--- eEYЂ݂XV
    stn_elast=stn_elast_trial+del_gamma
    stn_plast=stn_i-stn_elast
!
!--- e\iw֐fj牞͂vZ
    sts_i=sts0*EXP(-((1.0_p+voidr_0)/kappa)*stn_elast)
!
!--- d֐爳~͂vZ
    iso_hp_i=iso_hp0*EXP(-((1.0_p+voidr_0)/(lamda-kappa))*stn_plast)
!
!--- ~֐̒lvZC`FbN
    fyield=iso_hp_i-sts_i
!
    IF(ABS(fyield) < er_tol) EXIT
    IF(iter_retmap == max_iter) THEN
      WRITE(2,'(A,I10,A,I10)') &
        "!!! Retun map Not converged !!! ielem ",ielem," iintp ",iintp
      STOP
    END IF
!
!--- ~֐̑Y搔Ɋւ铱֐vZ
    del_fyield=iso_hp_i*((1.0_p+voidr_0)/(lamda-kappa)) &
              -sts_i*(-(1.0_p+voidr_0)/kappa)
!
!--- Y搔̏CʂvZ
    correct_del_gamma=-fyield/del_fyield
!
!--- Y搔XV
    del_gamma=del_gamma+correct_del_gamma
!
    END DO iteration_retmap
!
!--- eYڐW̐ݒ
    dep_i=-((1.0_p+voidr_0)/lamda)*iso_hp_i
!
!--- eEׁ^Yׂ̕I
  END IF
!
!--- XVꂽ͂ƈ~͂ۑpϐɋL^
  sts_e_i(ielem,iintp)=sts_i
  iso_hp_e_i(ielem,iintp)=iso_hp_i
!
END SUBROUTINE cal_stress3


