!====================================================================
SUBROUTINE input_base
  USE common
  IMPLICIT NONE
  CHARACTER(LEN=80):: title, filename
!
!--- {ϐ̓
  READ(1,*) title
  READ(1,*) n_mat, n_node, n_elem, n_bcs, n_nload
  READ(1,*) n_step
  READ(1,*) er_tol
  READ(1,*) reflag
!
  WRITE(2,'(/,A,A)') "Title: ", TRIM(title)
  WRITE(2,'(A,3I5)') &
  "n_mat, n_node, n_elem: ", n_mat, n_node, n_elem
  WRITE(2,'(A,I5)') &
  "n_bcs: ", n_bcs
  WRITE(2,'(A,I5)') &
  "n_nload: ", n_nload
  WRITE(2,'(A,I8)') &
  "n_step: ", n_step
  WRITE(2,'(A,E15.5)') &
  "er_tol: ", er_tol
  WRITE(2,'(A,I5)') &
  "reflag: ", reflag
!
!--- X^[gt@C̃I[v
  IF(reflag == 1) THEN
    READ(1,*) filename
    OPEN(7, FILE=filename)
    WRITE(2,'(/,A,A)') "Restart file name: ", TRIM(filename)
  END IF
!
END SUBROUTINE input_base
!====================================================================
SUBROUTINE input_bbc
  USE common
  IMPLICIT NONE
  INTEGER:: i, j, n
!
!--- yi̊{E̓
  IF(n_bcs/=0) THEN
    WRITE(2,'(/,A,I5)') "yi̊{E: ", n_bcs
!
    DO i=1,n_bcs
      READ(1,*) n, bcs_n(n), us_n(n)
!
      WRITE(2,'(A,I10,I5,E15.5)') &
      "n, bcs_n, us_n: ", n, bcs_n(n), us_n(n)
    END DO
  END IF
!
END SUBROUTINE input_bbc
!====================================================================
SUBROUTINE input_body
  USE common
  IMPLICIT NONE
!
  WRITE(2,'(/,A)') "̗: "
!
!--- ̗͂̓
  READ(1,*) bfc, inbody
  WRITE(2,'(A,I5,E15.5)') "bfc, inbody: ", bfc, inbody
!
END SUBROUTINE input_body
!====================================================================
SUBROUTINE input_geom
  USE common
  IMPLICIT NONE
  INTEGER:: i, j, k
!
  WRITE(2,'(/,A,I5)') "ߓ_ƍW: ", n_node
!
!--- ߓ_̓
  DO k=1,n_node
    READ(1,*) i, coord_n(i)
!
    IF(i > max_n) THEN
      WRITE(2,'(A,I5)') "Wrong node number at :", i
      STOP
    END IF
!
    IF(k /= i) THEN
      WRITE(2,'(A,I5)') "Wrong node number at :", i
      STOP
    END IF
!
    WRITE(2,'(A,I10,E15.5)') &
    "i, coord_n: ", i, coord_n(i)
  END DO
!
!
  WRITE(2,'(/,A, I5)') "vfƍ\ԍ: ", n_elem
!
!--- vf̓
  DO k=1,n_elem
    READ(1,*) i, mat_e(i), node_e(i,1:n_node_es)
!
    IF(i > max_e) THEN
      WRITE(2,'(A,I5)') "Wrong element number at :", i
      STOP
    END IF
!
    IF(k /= i) THEN
      WRITE(2,'(A,I5)') "Wrong element number at :", i
      STOP
    END IF
!
!--- vf̃`FbN
    DO j=1,n_int_es
      CALL set_initial_i
      iintp=j
      CALL set_lcoord_weight(n_int_es)
      ielem=i
      CALL cal_jac(n_node_es)
      IF(jac_i < 0.0_p) THEN
        WRITE(2,'(A,I10)') "vf: ",i,"̕sK؁D"
        STOP
      END IF
    END DO
!
    WRITE(2,'(A,I10,I5,3I10)') &
    "i, mat_e, node_e: ", i, mat_e(i), node_e(i,1:n_node_es)
  END DO
!
END SUBROUTINE input_geom
!====================================================================
SUBROUTINE input_mat
  USE common
  IMPLICIT NONE
  INTEGER:: i, j, k
!
  WRITE(2,'(/,A,I5)') "ޗ萔: ", n_mat
!
!--- ޗf[^̓
  DO k=1,n_mat
    READ(1,*) i, type_estr_m(i), & 
      n_prop_base(i), prop_base_m(i,1:n_prop_base(i)), &
      n_prop_estr(i), prop_estr_m(i,1:n_prop_estr(i))
!
    IF(i > max_m) THEN
      WRITE(2,'(A,I5)') "Wrong material number at :", i
      STOP
    END IF
!
    IF(k /= i) THEN
      WRITE(2,'(A,I5)') "Wrong material number at :", i
      STOP
    END IF
!
    IF(n_prop_base(i) > max_p) THEN
      WRITE(2,'(A,I5)') "Wrong n_prop_base at :", i
      STOP
    END IF
!
    IF(n_prop_estr(i) > max_p) THEN
      WRITE(2,'(A,I5)') "Wrong n_prop_estr at :", i
      STOP
    END IF
!
    WRITE(2,'(A,2I5)') &
    "i, type_estr_m: ", i, type_estr_m(i)
    WRITE(2,'(A,I5)') "n_prop_base: ", n_prop_base(i)
    DO j=1,n_prop_base(i)
      WRITE(2,'(A,I5,E15.5)') "prop no.: ", j, prop_base_m(i,j)
    END DO
    WRITE(2,'(A,I5)') "n_prop_estr: ", n_prop_estr(i)
    DO j=1,n_prop_estr(i)
      WRITE(2,'(A,I5,E15.5)') "prop no.: ", j, prop_estr_m(i,j)
    END DO
  END DO
!
END SUBROUTINE input_mat
!====================================================================
SUBROUTINE input_nbc
  USE common
  IMPLICIT NONE
  INTEGER:: i, j, n
!
!--- yi̐ߓ_׏d̓
  IF(n_nload/=0) THEN
!
    WRITE(2,'(/,A,I5)') "yi̐ߓ_׏d: ", n_nload
!
    DO i=1,n_nload
      READ(1,*) n, lcs_n(n), nload_n(n)
!
      WRITE(2,'(A,I10,I5,E15.5)') &
      "n, lcs_n, nload_n: ", n, lcs_n(n), nload_n(n)
!
    END DO
  END IF
!
END SUBROUTINE input_nbc
!====================================================================
SUBROUTINE input_rest
  USE common
  IMPLICIT NONE
!
  READ(7,*) coord_n(1:n_node), &
  us_n(1:n_node), &
  sts_e_i(1:n_elem,1:n_int_es), &
  iso_hp_e_i(1:n_elem,1:n_int_es)
!
END SUBROUTINE input_rest
