!====================================================================
SUBROUTINE set_body
  USE common
  IMPLICIT NONE
!
  IF(bfc == 1) THEN
    body= inbody
  ELSEIF(bfc == 2) THEN
    body= inbody*REAL(istep)
  END IF
!
END SUBROUTINE set_body
!====================================================================
SUBROUTINE set_dof
  USE common
  IMPLICIT NONE
  INTEGER:: i, j, k, n
  INTEGER:: flags(max_n)
!
!--- ftHg̎Rx̐ݒ
  flags=0
  DO i=1,n_elem
    flags(node_e(i,1:n_node_es))=1
  END DO
!
!--- Rxԍ̐ݒ
  n_dof=0
  DO i=1,n_node
    IF(flags(i)/=0) THEN
      IF(bcs_n(i)==0) THEN
        n_dof=n_dof+1
        dof_ns(i)=n_dof
      END IF
    END IF
  END DO
!
  IF(n_dof > max_d) THEN
    WRITE(2,'(A,I5)') "Wrong dof number at :", n_dof
    STOP
  END IF
!
!--- o
  WRITE(2,'(/,A,I10)') "SRx: ", n_dof 
  WRITE(2,'(A)') "RxXg: " 
  DO i=1,n_dof
    DO j=1,n_node
      IF(dof_ns(j)==i) &
        WRITE(2,'(A,2I10)') "inode, dof_ns: ",j,dof_ns(j)
    END DO
  END DO
!
END SUBROUTINE set_dof
!====================================================================
SUBROUTINE set_grvec(dofn,rvec_i)
  USE common
  IMPLICIT NONE
  INTEGER:: dofn
  REAL(p),INTENT(IN):: rvec_i
!
!--- S̎cxNgւ̊i[
  IF(dofn>n_dof) THEN
    WRITE(2,'(A,I5)') "Wrong dofn in set_grvec: ", dofn
    STOP
  END IF
  grvec(dofn)=grvec(dofn)-rvec_i*jac_i*weight_i
!
END SUBROUTINE set_grvec
!====================================================================
SUBROUTINE set_gtmat(dofn,dofm,tmat_i)
  USE common
  IMPLICIT NONE
  INTEGER:: dofn, dofm
  REAL(p),INTENT(IN):: tmat_i
!
!--- S̐ڐW}gbNXւ̊i[
  IF(dofm>n_dof) THEN
    WRITE(2,'(A,2I10)') "Wrong j column in set_gtmat: ",dofn,dofm
    STOP
  END IF
  gtmat(dofn,dofm)=gtmat(dofn,dofm)+tmat_i*jac_i*weight_i
!
END SUBROUTINE set_gtmat
!====================================================================
SUBROUTINE set_initial_i
  USE common
  IMPLICIT NONE
!
  jac_i=0.0_p; lcoord_i=0.0_p; weight_i=0.0_p
  dnadzs_i=0.0_p; dnbdzs_i=0.0_p
  shapeas_i=0.0_p
  poro_i=0.0_p; voidr_i=0.0_p
  dens_mix_i=0.0_p; dens_mix0_i=0.0_p
  sts_i=0.0_p
  stn_i=0.0_p 
  del_stn_i=0.0_p
  dep_i=0.0_p
  iso_hp_i=0.0_p
!
END SUBROUTINE set_initial_i
!====================================================================
SUBROUTINE set_lcoord_weight(n_int_e)
  USE common
  IMPLICIT NONE
  INTEGER:: n_int_e
  REAL(p):: value, lcoord(1:n_int_e), weight(1:n_int_e)
!
  lcoord_i=0.0_p
  weight_i=0.0_p
  lcoord=0.0_p
  weight=0.0_p
!
!--- ϕ_̋ǏWяd݂̐ݒ
  SELECT CASE(n_int_e)
  CASE(1)
    lcoord(1)=0.0_p
    weight(1)=2.0_p
  CASE(2)
    value=1.0_p/SQRT(3.0_p)
    lcoord(1)=-value
    lcoord(2)= value
    weight(1:n_int_e)=1.0_p
  CASE(3)
    value=0.2_p*SQRT(15.0_p)
    lcoord(1)=-value
    lcoord(2)= 0.0_p
    lcoord(3)= value
    weight(1)=5.0_p/9.0_p
    weight(2)=8.0_p/9.0_p
    weight(3)=5.0_p/9.0_p
  CASE DEFAULT
    WRITE(2,'(A)') "Wrong number of integrating points in sub.set_lcoord_weight"
    STOP
  END SELECT
!
!--- Yϕ_̋ǏWƏd݂̐ݒ
  lcoord_i=lcoord(iintp)
  weight_i=weight(iintp)
!
END SUBROUTINE set_lcoord_weight
!====================================================================
SUBROUTINE set_nvalue_nb
  USE common
  IMPLICIT NONE
  INTEGER:: i, j, k, dofn
  REAL(p):: rvec_i
!
  jac_i=1.0_p; weight_i=1.0_p
!
  DO i=1,n_node
!
!--- ߓ_
    rvec_i=0.0_p
    IF(lcs_n(i) == 1) THEN
      rvec_i= -nload_n(i)
    ELSEIF(lcs_n(i) == 2) THEN
      rvec_i= -nload_n(i)*REAL(istep)
    END IF
!
!--- S̎cxNgւ̐ݒ
    IF(lcs_n(i) /= 0) THEN
      dofn=dof_ns(i)
      IF(dofn/=0) CALL set_grvec(dofn,rvec_i)
    END IF
!
  END DO
!
END SUBROUTINE set_nvalue_nb
!====================================================================
SUBROUTINE set_sts_vec
  USE common
  IMPLICIT NONE
!
  sts_e_i(ielem,iintp)=sts_i
!
END SUBROUTINE set_sts_vec

